/* AMBCONV - program for convering AMBER topology to GROMACS/TINKER topology */
/* Filip Ryjacek 2002 */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <stddef.h>
#include <string.h>
#include <math.h>
/* #include <mcheck.h> */

#include "ambconv.h"

// write charges to TINKER topology file (.prm)
void write_tintop_charge(s_atop* atop)
  {
    unsigned int i;
    double charge;
    double total_charge;
    char* atomname;

#ifdef DEBUG_TTOP
  printf("\nwrite_tintop_charge: opening %s...\n", tintop_filename);
#endif
    tintop = open_file(tintop_filename, "a");

atomname = (char*) xmalloc(5);
total_charge = 0.0;

    // write header
    fprintf(tintop, "# Charges\n\n");

    for (i=0; i < atop->natom; i++)
      {
        // get atom name
	atomname = get_slice(atop->igraph, atomname, 4,4, i);
      
        charge = atop->chrg[i];
        total_charge = total_charge + charge;
 
        fprintf(tintop, "charge%10d%12.6f", i+1, charge);
	fprintf(tintop,"  # %4s\n", atomname);
      }

    fprintf(tintop, "\n# total charge: %10.4f\n", total_charge);
    
    close_file(tintop);

#ifdef DEBUG_TTOP
    printf("write_tintop_charge: %s closed.\n", tintop_filename);    
#endif

#ifdef USE_FREE
free(atomname);
#endif

  }


